.de Sh
.br
.ne 5
.PP
\fB\\$1\fR
.PP
..
.de Sp
.if t .sp .5v
.if n .sp
..
.               \" Path Name
.               \"      uses Courier fonts for V4.0
.de PN
.ie t \&\f(CB\\$1\f(NR\\$2
.el \fI\\$1\fP\\$2
..
.		\" The following macros added by dpwe for Ultrix 4..
.               \" Manual section reference
.               \"      uses Courier fonts for V4.0
.de MS
.ie t \&\f(CB\\$1\f(NR(\\$2)\\$3
.el \fI\\$1\fP(\\$2)\\$3
..
.de EX		\" Begin Example
.ie \\n(.$ .nr EX \\$1n
.el \{\
.	ie n .nr EX 0n
.	el .nr EX 0n
.\}
.in +\\n(EXu
.if n .sp 1
.if t .sp .5v
.nf
.CW
.ft CB
..
.de EE		\" End example
.in -\\n(EXu
.fi
.}f             \" restore basic text attributes
.if n .sp 1
.if t .sp .5v
..
.TH FFWD 1 "1999 oct 23" dpwe   \" $Header: /u/drspeech/src/ffwd/RCS/ffwd.man,v 1.3 2000/08/18 06:29:21 dpwe Exp $
.SH NAME
ffwd - fast forward-pass for neural networks
.SH SYNOPSIS
\fBffwd
[\-ninp \fInumInputs\fB]
[\-nhid \fInumHidden\fB]
[\-nout \fInumOutputs\fB]
[\-width \fIw\fB]
[\-cw \fIcontextWindow\fB]
[\-bsize \fIbunchSize\fB]
[\-ifile \fIinFile\fB]
[\-ofile \fIoutFile\fB]
[\-wfile \fIweightsFile\fB]
[\-nfile \fInormsFile\fB]
[\-onlnorm]
[\-alpha_m \fIa\fB]
[\-alpha_v \fIb\fB]
\fR
.SH DESCRIPTION
.PN ffwd
is a small and fast neural-net forward-pass calculation program.  It 
is a drop-in replacement for certain uses of 
.MS qnsfwd 1
but has the advantage of being in pure C, being much smaller, and 
potentially easier to optimize (e.g. via phipac).
.P
To keep it small and simple, it supports input features only 
in 
.MS online_ftrs 5
format, and writes output in 
.MS lna 5
format (although
.MS rapbin 5
is available as a compile-time option).
.SH OPTIONS
.P
.PD 0
.B -ninp \fIi\fR
.P
.B -nhid \fIh\fR
.TP
.PD 1
.B -nout \fIo\fR
Specify the geometry of the neural network described by the weights
file.  This must of course be consistent with the number of weights
etc. in the file.  The number of inputs must also equal the context
window width times the input stream width.
.TP
.B -width \fIw\fR
The number of features in each frame of the input online feature 
format stream (this is not detectable from an 
.MS online_ftrs 5
stream).
.TP
.B -cw \fIc\fR
The number of consecutive feature vectors which are assembled into 
a single input pattern for presentation to the net.  Each successive 
net output corresponds to sliding the context window by one vector, 
but there will be fewer output frames than input frames since only 
complete context windows will be processed.
.TP
.B -bsize \fIb\fR
The blocking factor for the forward pass.  Patterns will be 
accumulated into blocks of this size before running the forward 
pass.  Generally, larger is faster until the working memory set 
exceeds cache or something.
.TP
.B -ifile \fIname\fR
Name of the input 
.MS online_ftrs 5 
stream.  "-" means to read from standard input.
.TP
.B -ofile \fIname\fR
Name for the output 
.MS lna 5 
stream.  "-" means to write to standard output.
.TP
.B -wfile \fIname\fR
Name of the network weights definition file.  This is in the 
ASCII MLP3 format as written by 
.TP
.B -nfile \fIname\fR
Name of the optional norms file.  If present, it is read to obtain 
the means to be subtracted from each column in the feature vectors, 
and the inverse-standard-deviations by which to scale each difference.  
This file is in the format written by
.MS qnnorm 1
or 
.MS olfnorms 1 .
.TP
.B -onlnorm
Apply simple, first-order online mean and variance normalization to 
each feature dimension (equivalent to ftrX_norm_mode=onl for 
.MS qnsfwd 
etc.).  You must also specify a -nfile to provide initialization 
for the online normalization coefficients.
.PD 0
.B -alpha_m \fIa\fR (0.005)
.TP
.PD 1
.B -alpha_v \fIb\fR (0.005)
Update constants for the means and variances (respectively) when 
running -onlnorm.  At each step, the existing mean or variance 
value is scaled by (1 - alpha), and alpha times the current value 
is added on.
.SH BUGS
Tested rather little at present.  Multiple segments, piped input and 
output, and other features are believed working but untried.
.SH NOTES
Core by Jeff Bilmes, adapted to work with standard file formats by Dan Ellis.
.SH SEE ALSO
.MS qnsfwd 1 ,
.MS qnnorm 1 ,
.MS olfnorms 1 .
.SH AUTHORS
Jeff Bilmes, 
.B bilmes@icsi.berkeley.edu 
and Dan Ellis, 
.B dpwe@icsi.berkeley.edu 
